/**************************************************************************
   FILE         : propagate_1.c
   SNNS VERSION : 2.1

   PURPOSE      : pattern propagation demo-example using C neural networks
                  performed by runtime.c to propagate
                  either patterns from a file or new defined ones.

   NOTES        : This source may be copied and modified appropriatly 
                  by the user
 
   AUTHOR       : Kais Brahim
   VERSION      : 1.0
   CHANGED BY   : Dietmar Posselt (05.07.93)

   DATE         : 15.11.92

             Copyright (c) 1990-1993  SNNS Group, IPVR, Univ. Stuttgart, FRG

*****************************************************************************/

#include <stdio.h>
#include "runtime.h"


main()

{
    Patterns in_patterns, out_patterns;

    FILE *out_file, *in_file;

    float    InPattern[NO_OF_IN_UNITS], OutPattern[NO_OF_OUT_UNITS];

    int  start_pattern = 1, err;

    printf("initializing network ...\n");
    
    err = Init_Net(); 
    if (err)
    {
	printf ("%s", err_chk(err));
	exit (1);
    }
    
    /* load patterns from the file PAT_IN_FILE in the array in_patterns
       and allocate memory for the array out_patterns  
    */
    
    printf("reading patterns from file %s ...\n", PAT_IN_FILE);
    
    if (!(in_file=fopen(PAT_IN_FILE,"r")))
    {
	printf ("Cannot open input-file !\n");
	exit (1);
    }
    
    err = Load_Pattern_File(in_file, &in_patterns, &out_patterns);
    if (err)
    {
	printf ("%s", err_chk(err));
	exit (1);
    }
    
    /*  propagate in_patterns and save 
	the network output patterns  in the array out_patterns 
    */
    
    printf("propagating patterns through network ...\n");
    
    err= Propagate_Pattern_Array(in_patterns, out_patterns);
    if (err)
    {
	printf ("%s", err_chk(err));
	exit (1);
    }
    
    /* write patterns to result file:
       PAT_RES_FILE  : the result file name
       start_pattern : the first pattern number
       in_patterns   : pointer to the input pattern array,
                       if NULL => write no input patterns.  
       out_patterns  : pointer to the output pattern array,
                       if NULL => write no output patterns.
    */
    
    printf("creating result file %s ...\n", PAT_RES_FILE);
    
    if (!(out_file=fopen(PAT_RES_FILE,"w")))
    {
	printf ("Cannot open output-file !\n");
	exit (1);
    }
    
    err = Write_Pattern_Arrays(out_file, start_pattern, 
			       in_patterns, out_patterns);
    if (err)
    {
	printf ("%s", err_chk(err));
	exit (1);
    }
}
